/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2015 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G14 V2.04.01.03 [30 Jan 2015]
* Device(s)    : R5F104LE
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2015/07/27
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
#include "r_cg_timer.h"
#include "r_cg_it.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
#pragma interrupt INTIT r_it_interrupt rb2
#pragma interrupt INTIIC01 r_iic01_interrupt rb1
#pragma interrupt INTTM03 r_inttm03_interrupt rb2
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */

#define     WAITMODE                    /* insert wait for LCD module   */

#define     slaveaddr   (0xA0)          /* IIC bus slave address        */

/*----------------------------------------------

    instruction code for LCD

-----------------------------------------------*/

#define     COMBYTE     (0x00)          /* control byte for command     */
#define     DATABYTE    (0x80)          /* control byte for data        */
#define     CLRDISP     (0x01)          /* clear display instruction    */
#define     HOMEPOSI    (0x02)          /* home position instruction    */
#define     LCD_Mode    (0b00111000)    /* operation mode instruction   */
/*                         ++||||------ must be 0
                             +|||------ must be 1
                              ||+------ 5*10/5*8dots
                              |+------- 2line/1line
                              +-------- data lengt 8bit(FIX)
*/
#define     DISPON      (0b00001100)    /* display on instruction   */
/*                         ++++||||---- must be 0
                               +|||---- must be 1
                                ||+---- blinking of cursor
                                |+----- cursor
                                +------ display
*/
#define     ENTRY_Mode  (0b00000110)    /* entry mode instruction   */
/*                         +++++|||---- must be 0
                                +||---- must be 1
                                 |+---- shift
                                 +----- shift direction
*/

volatile uint8_t   g_TM03flag;          /* TM03 count end flag  */
//volatile uint8_t   g_TM03cnt;           /* TM03 counter         */
volatile uint8_t   g_05s_status;        /* 0.5s interrupt flag  */
volatile uint8_t   g_05s_count;         /* 0.5s counter         */
static const uint8_t dispdata1[] = {"Renesas RL78/G14 Renesas RL78/G1"};

volatile uint8_t   g_iic01_status;	/* iic01 master operationflag   */
/*  00 : operation end witout error
    01 : transmit operating 
    81 : operating receive start
    41 : receive operating
    FF : operation error
*/

volatile uint8_t   *gp_iic01_tx_address;/* transmit data pointer    */
volatile uint16_t  g_iic01_tx_cnt;      /* transmit data counter    */
volatile uint8_t   *gp_iic01_rx_address;/* received data store pointer  */
volatile uint16_t  g_iic01_rx_cnt;      /* received data counter    */
volatile uint16_t  g_iic01_rx_len;      /* receive data number      */


volatile uint8_t    g_write_commmand[2];/* command transmit buffer  */
volatile uint8_t    g_write_data[2];    /* data trnasmit buffer     */

void R_IIC01_Master_Send(uint8_t adr, uint8_t * const tx_buf, uint16_t tx_num);
                                        /* transmit datas in buffer to slave*/
void R_IIC01_Master_Receive(uint8_t adr, uint8_t * const rx_buf, uint16_t rx_num);
                                        /* receive datas from slave */
MD_STATUS R_IIC01_wait_comend(void);    /* wait for transfer end    */

void R_IIC01_start_condition(void);     /* issue start condition and 
                                         transmit slave address     */
void R_IIC01_StopCondition(void);

void set_1digit( uint8_t data);
void set_2digit( uint8_t data);

void init_LCD(void);
MD_STATUS set_data(uint8_t datacode);
MD_STATUS set_command(uint8_t comcode);
void wait_time(uint8_t time);
void wait_5us(void);

/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
  {

    uint8_t CNT,DISPCNT;

    DISPCNT = 0x00;
    while (1U)
    {

        while ( g_05s_status == 0 )     /* wait for IT intrrupt     */
        {
            NOP();
            STOP();
        }
        g_05s_status = 0;               /* clear 0.5s flag          */

        P6.3 = P13.7;

        set_command(0b10000000);        /* move pointer to top      */

/* shift and display data   */
        for (CNT = 0 ; CNT < 16 ; CNT++ )
        {
            set_data(dispdata1[CNT+DISPCNT]);
        }

        DISPCNT++;

        if ( DISPCNT == 16 )
        {
            DISPCNT = 0;
        }

    }
  }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */

    uint8_t CNT;

    P6.3 = 1;
    PM6.3 = 0;
    PMK0 = 1;

/* use TM02 & TM03 for delay count mode */

    TMR03 = 0x09;                       /* disable edge detection   */
    TMR02 = 0x09;                       /* disable edge detection   */
    TS0 = 0x0C;                         /* enable TM02 & TM03       */
    TMMK02 = 1;                         /* mask TM02 interrupt      */
    TMIF02 = 0;
    TMMK03 = 1;                         /* mask TM03 interrupt      */
    g_TM03flag = 1;                     /* set ready                */

/* enable IIC01 interrupt   */
    IICIF01 = 0;
    IICMK01 = 0;

/* start IT                       */

    g_05s_status = 0;
    g_05s_count = 0;
    ITMC |= 0x8000;                     /* start IT		            */
    ITIF = 0;                           /* clear interrupt flag	    */
    ITMK = 0;                           /* enable IT interrupt	    */

    EI();

    while ( g_05s_status == 0 )         /* wait for 0.5s	        */
    {
        NOP();
    }
	g_05s_status = 0;


/*--------------------------------------
    LCD initialize
----------------------------------------*/


    init_LCD();                         /* initialize LCD           */

/* display 1st line */

    for ( CNT = 0 ; CNT < 16 ; CNT++ )
    {
        set_data(dispdata1[CNT]);

    }


    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/*******************************************************************************
* Function Name: init_LCD
* Description  : This function initialize LCD
* Arguments    : none
* Return Value : none
********************************************************************************/
void init_LCD(void)
{
    set_command(CLRDISP);               /* initialize LCD display   */
    wait_time(240);                     /* wait for 20us*240=4.8ms  */
    set_command(LCD_Mode);              /* set LCD operation mode   */
    set_command(DISPON);                /* display on               */
    set_command(ENTRY_Mode);            /* set data entry mode      */
}

/*******************************************************************************
* Function Name: set_2digit
* Description  : This function display 2 digit(low nibble of data)
* Arguments    : display nimber
* Return Value : none
********************************************************************************/
void set_2digit( uint8_t data)
{
    set_1digit( data >> 4 );            /* display high nibble      */
    set_1digit( data );                 /* display low nibble       */
}

/*******************************************************************************
* Function Name: set_1digit
* Description  : This function display 1 digit(low nibble of data)
* Arguments    : display nimber
* Return Value : none
********************************************************************************/
void set_1digit( uint8_t data)
{
    set_data((data & 0x0F)+0x30);       /* display 1digit           */
}


/*******************************************************************************
* Function Name: set_command
* Description  : This function send command to LCD
* Arguments    : command code
* Return Value : result
                0x00 : success
                other : error
********************************************************************************/
MD_STATUS set_command(uint8_t comcode)
{

    MD_STATUS status;

    g_write_commmand[0] = COMBYTE;      /* issue start condition        */
    g_write_commmand[1] = comcode;		/* set command instruction      */

    R_IIC01_Master_Send( slaveaddr , (uint8_t *__near)g_write_commmand , 2 );

    status = R_IIC01_wait_comend();     /* wait for transmit address    */

    R_IIC01_StopCondition();            /* issue stop condition         */

#ifndef WAITMODE
    wait_time(1);                       /* wait for 20us to next        */
#endif

    return (status);

}

/*******************************************************************************
* Function Name: set_data
* Description  : This function send data to LCD
* Arguments    : data code
* Return Value : result
                0x00 : success
                other : error
********************************************************************************/
MD_STATUS set_data(uint8_t datacode)
{

    MD_STATUS status;

    g_write_data[0] = DATABYTE;         /* set command for LCD      */
    g_write_data[1] = datacode;         /* set data for LCD         */

/*
    send command instruction to LCD
*/
    R_IIC01_Master_Send( slaveaddr , (uint8_t *__near)g_write_data , 2 );

    status = R_IIC01_wait_comend();     /* wait for transmit address    */

    R_IIC01_StopCondition();            /* issue stop condition         */

#ifndef WAITMODE
    wait_time(1);                       /* wait for 20us to next        */
#endif

    return (status);

}

/*******************************************************************************
* Function Name: wait_time
* Description  : This function wait time
* Arguments    : wait time by 20us
* Return Value : none
********************************************************************************/
void wait_time(uint8_t time)
{
    uint8_t work;
    for ( work = time ; work > 0 ; work-- )
    {
        wait_5us();                     /* wait 5us                     */
        wait_5us();                     /* wait 5us                     */
        wait_5us();                     /* wait 5us                     */
        wait_5us();                     /* wait 5us                     */
    }
}

/*******************************************************************************
* Function Name: wait_5us
* Description  : This function wait 5us
* Arguments    : none
* Return Value : none
********************************************************************************/
void wait_5us(void)
{

    TMIF02 = 0;
    TS0 = 0x04;                         /* trigger TM02                 */
    while ( TMIF02 == 0 )               /* wait for TM02 count up       */
    {
        NOP();
    }
}


/*******************************************************************************
* Function Name: R_IIC01_start_condition
* Description  : This function issue start condition
* Arguments    : none
* Return Value : none
********************************************************************************/
void R_IIC01_start_condition(void)
{

    while (g_TM03flag == 0)             /* wait for previous execution  */
    {
        NOP();
    }

    wait_5us();                         /* wait for bus free time       */

    SO0 &= ~0x0002;                     /* fall down SDA when in SCL=H  */

    wait_5us();                         /* wait for bus setup time      */

#ifndef WAITMODE
    wait_time(2);                       /* wait for hold time  40us     */
#endif

    SO0 &= ~0x0200;                     /* fall down SCL after SDA =L   */

    SOE0 |= 0x02;                       /* enable channel01 output      */
    SCR01 |= 0x8000;                    /* set transmit enable          */
    SS0 = 0x02;                         /* enable channel01 operation   */

    wait_5us();                         /* for command interval         */

#ifndef WAITMODE
    wait_time(1);                       /* wait for 20us to next        */
#endif

}

/*******************************************************************************
* Function Name: R_IIC01_Master_Send
* Description  : This function starts IIC01 in transmision mode.
* Arguments    : adr -
*                    slave address
*                tx_buf -
*                    transfer data pointer
*                tx_num -
*                    transmit data number
* Return Value : none
*                    none
********************************************************************************/
void R_IIC01_Master_Send(uint8_t adr, uint8_t * const tx_buf, uint16_t tx_num)
{

    /* copy transfer parameters */
    g_iic01_tx_cnt = tx_num;            /* set data number to transmit  */
    gp_iic01_tx_address = tx_buf;       /* set data pointer             */

    /* start to access IIC bus  */

    R_IIC01_start_condition();          /* issue start condition        */

    g_iic01_status = 0x01;              /* set execution flag           */

    SIO01 = adr & 0xFE;                 /* transmit slave address       */

}

/*******************************************************************************
* Function Name: R_IIC01_Master_Receive
* Description  : This function starts IIC01 in receive mode.
* Arguments    : adr -
*                    slave address
*                rx_buf -
*                    received data buffer pointer
*                rx_num -
*                    receive data size+1
* Return Value : status -
*                    none
********************************************************************************/
void R_IIC01_Master_Receive(uint8_t adr, uint8_t * const rx_buf, uint16_t rx_num)
{

    /* copy parameters  */

    g_iic01_rx_len = rx_num;            /* set data number to transmit  */
    g_iic01_rx_cnt = 0U;
    gp_iic01_rx_address = rx_buf;       /* set data pointer             */

    /* start to access IIC bus  */

    /* start to access IIC bus  */

    R_IIC01_start_condition();          /* issue start condition        */

    g_iic01_status = 0x81;              /* set execution flag           */

    SIO01 = adr | 0x01;                 /* transmit slave address       */

}


/*******************************************************************************
* Function Name: R_IIC01_StopCondition
* Description  : This function issue start condition
* Arguments    : none
* Return Value : none
********************************************************************************/
void R_IIC01_StopCondition(void)
{

    wait_time(1);                       /* dummy wait 20us              */

    ST0 |= 0x0002;                      /* disable IIC01 operation      */
    SOE0 &= ~0x0002;                    /* disable IIC01 output         */
    SO0 &= ~0x0002;                     /* fall down SDA signal         */
    SO0 |= 0x0200;                      /* rise up SCL signal           */

    wait_time(1);                       /* wait for execution time      */

    SO0 |= 0x0002;                      /* rise up SDA signal           */

    g_TM03flag = 1;

#ifndef WAITMODE
    wait_time(1);
#endif

}

/*******************************************************************************
* Function Name: R_IIC01_wait_comend
* Description  : This function wait for communication end
* Arguments    : none
* Return Value : result status
                0x00 : success
                other : error
********************************************************************************/
MD_STATUS R_IIC01_wait_comend(void)
{
    MD_STATUS status;

    while( (g_iic01_status & 0x3F) == 0x01 )
    {
        NOP();                                  /* wait for communication end   */
    }

    status = g_iic01_status;                    /* set result status            */

    return( status );
}

/********************************************************************************
* Function Name: r_iic01_interrupt
* Description  : This function is IIC01 interrupt service routine.
                ( only start TM03 operation. )
* Arguments    : None
* Return Value : None
*********************************************************************************/
__interrupt static void r_iic01_interrupt(void)
{

    TMIF03 = 0;                         /* clear TM03 interrupt flag    */
    TS0 = 0x08;                         /* start TM03                   */

    TMMK03 = 0;                         /* enable TM03 vector interrupt */
}

/********************************************************************************
* Function Name: r_inttm03_interrupt
* Description  : This function is TM03 interrupt service routine.
                ( actual procedure of IIC01 interrupt. )
* Arguments    : None
* Return Value : None
*********************************************************************************/
__interrupt static void r_inttm03_interrupt(void)
{

    uint8_t work;                       /* work register            */

    g_TM03flag = 1;                     /* set TM03 count end flag  */

    TMMK03 =1;                          /* mask TM03 interrupt      */

    if ( ( g_iic01_status & 0x3F ) == 0x01 )
    {                                   /* IIC01 is working         */

        work = SSR01L;                   /* read result falg         */

        if( work & 0x02 )               /* NACK from slave          */
        {
            SIR01L = work;              /* clear error flag         */
            g_iic01_status = 0xFF;      /* set error flag           */
        }
        else                            /* ACK from slave           */
        {
            if( g_iic01_status == 0x01 )    /* transmit data operation  */
            {
                if ( g_iic01_tx_cnt > 0 )   /* more data to transmit    */
                {
                    SIO01 = *gp_iic01_tx_address;   /* set transmit data*/
                    gp_iic01_tx_address++;  /* move pointer to next data*/
                    g_iic01_tx_cnt--;   /* count down data number   */
                }
                else                    /* data transmit complete   */
                {
                    g_iic01_status = 0; /* set data transfer end    */
                }
            }
            else 

/*===================================================================

    data receive operation

    g_iic01_status = 0x41 : data received
    g_iic01_status = 0x81 : slave address is transmitted

    
=====================================================================*/
            {
                if ( g_iic01_status == 0x41 )   /* receive operation    */
                {
                    *gp_iic01_rx_address = SIO01;   /* store received data*/

                    if ( g_iic01_rx_cnt < g_iic01_rx_len )
                    {
/*-------------------------------------------------------------------
    more data to receive is exist
---------------------------------------------------------------------*/

                        gp_iic01_rx_address++;  /* move pointer to next data*/
                        g_iic01_rx_cnt++;   /* count down data number   */

                        if ( g_iic01_rx_cnt == g_iic01_rx_len )
                        {
/*-------------------------------------------------------------------
    next data is last data to receive. then NACK response
---------------------------------------------------------------------*/

                            SOE0 &= ~0x02;  /* disable output for NACK  */
                        }
                        SIO01 = 0xFF;   /* start next receive data  */

                    }
                    else                /* data receive complete    */
                    {

                        g_iic01_status = 0x00;  /* set success flag */
                    }
                }
                else
                {
                    if (g_iic01_status == 0x81 )
                    {
/*-------------------------------------------------------------------
    slave address end and start receive
---------------------------------------------------------------------*/
                        ST0 = 0x02;     /* stop IIC01 operaion      */
                        SCR01 ^= 0xC000;/* TX disable & enable RX   */
                        SS0 = 0x02;     /* start IIC01 operation    */
                        SIO01 = 0xFF;   /* trigger RX operation     */
                    }
                }
            }
        }
    }

}

/********************************************************************************
* Function Name: r_it_interrupt
* Description  : This function is 0.1sec interrupt service routine.
* Arguments    : None
* Return Value : None
*********************************************************************************/
__interrupt static void r_it_interrupt(void)
{

    g_05s_count++;
    if( g_05s_count == 5 )
    {
        g_05s_status = 1;               /* set 0.5s flag            */
        g_05s_count = 0;
    }


}

/* End user code. Do not edit comment generated here */
